require 'thread'
module Tmc
  module Commands
    module Lint
      class Linter

        def initialize(dir)
          @queue = Array.new
          @project_dir = Array.new
          @config_files = Array.new
          @base_dir = File.expand_path(dir)
          @queue << @base_dir
        end

        def recursive_lint(dir)
          puts "Checking #{dir} recursively"
          if project_dir?(dir)
            @project_dir << dir
          end
          Dir.glob(File.join(dir, '*')).each do |d|
            if File.directory? d
              recursive_lint(d)
            elsif config_file?(d)
              @config_files << d
            end
          end
        end

        def lint!
          recursive_lint(@base_dir)
        end

        def config_file?(file)
          config_file_name = file.split("/")[-1]
          %w(metadata.yml course_options.yml).include? config_file_name
        end

        def project_dir?(dir)
          dir_contains_files?(dir, %w(src test))
        end

        def dir_contains_files?(dir, check)
          dirs = Dir.glob(File.join(dir, '*'))
          dirs.each do |d|
            check.delete d.gsub(dir + "/","")
          end
          check.empty?
        end
      end
    end
  end
end
